package net.mcreator.laboratory.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.boss.WitherEntity;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.model.WitherModel;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.layers.EnergyLayer;
import net.minecraft.client.renderer.entity.MobRenderer;
import net.minecraft.client.renderer.entity.IEntityRenderer;

import net.mcreator.laboratory.entity.GoldWitherEntity;

@OnlyIn(Dist.CLIENT)
public class GoldWitherRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(GoldWitherEntity.entity,
					renderManager -> new MobRenderer(renderManager, new WitherModel(0), 0.5f) {
						{
							this.addLayer(new GoldWitherAuraLayer(this));
						}
						@Override
						public ResourceLocation getEntityTexture(Entity entity) {
							int i = ((WitherEntity) entity).getInvulTime();
							return i > 0 && (i > 80 || i / 5 % 2 != 1)
									? new ResourceLocation("laboratory:textures/gold_wither_invulnerable.png")
									: new ResourceLocation("laboratory:textures/gold_wither.png");
						}
					});
		}
	}

	@OnlyIn(Dist.CLIENT)
	private static class GoldWitherAuraLayer extends EnergyLayer<WitherEntity, WitherModel<WitherEntity>> {
		private static final ResourceLocation WITHER_ARMOR = new ResourceLocation("laboratory:textures/gold_wither_armor.png");
		private final WitherModel<WitherEntity> witherModel = new WitherModel<>(0.5F);
		public GoldWitherAuraLayer(IEntityRenderer<WitherEntity, WitherModel<WitherEntity>> p_i50915_1_) {
			super(p_i50915_1_);
		}

		protected float func_225634_a_(float p_225634_1_) {
			return MathHelper.cos(p_225634_1_ * 0.02F) * 3.0F;
		}

		protected ResourceLocation func_225633_a_() {
			return WITHER_ARMOR;
		}

		protected EntityModel<WitherEntity> func_225635_b_() {
			return this.witherModel;
		}
	}
}
